﻿Option Strict On
Imports Microsoft.Phone.Tasks
Imports System.Windows.Media.Imaging
Imports Microsoft.Phone
Imports System.IO
Imports System.Xml.Linq
Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' コンストラクター
    Public Sub New()
        InitializeComponent()
    End Sub

    Dim imageByte As Byte()

    Dim myCameraTask As CameraCaptureTask

    Dim imageFileName As String
    Const UploadUri As String = "ユーザの専用サーバのURL/ImageFileUpload/Default.aspx?fileName={0}"
    Protected Overrides Sub OnNavigatedTo(e As System.Windows.Navigation.NavigationEventArgs)
        myCameraTask = New CameraCaptureTask


        Dim myWebClient As New WebClient

        AddHandler myWebClient.DownloadStringCompleted, Sub(resultSender As Object, resultArgs As DownloadStringCompletedEventArgs)
                                                            If resultArgs.Error Is Nothing = False Then
                                                                MessageBox.Show("XMLファイルが見つかりません")
                                                                Exit Sub
                                                            Else
                                                                Dim myDoc As XElement = XElement.Parse(resultArgs.Result)
                                                                Dim query = From c In myDoc.Descendants("fileName") Select c
                                                                If query.Count > 0 Then
                                                                    ichiranButton.IsEnabled = True
                                                                Else
                                                                    ichiranButton.IsEnabled = False
                                                                End If

                                                            End If
                                                        End Sub
        myWebClient.DownloadStringAsync(New Uri(String.Format("ユーザの専用サーバのURL/ImageFileUpload/ImageData/ImageInfo.xml?myTime={0}", DateTime.Now.ToLongTimeString), UriKind.Absolute))


        AddHandler myCameraTask.Completed, Sub(resultSender As Object, resultArgs As PhotoResult)
                                               If resultArgs.TaskResult = TaskResult.OK Then
                                                   imageByte = New Byte(CInt(resultArgs.ChosenPhoto.Length)) {}
                                                   resultArgs.ChosenPhoto.Read(imageByte, 0, imageByte.Length)
                                                   'ImageData = resultArgs.ChosenPhoto
                                                   resultArgs.ChosenPhoto.Seek(0, IO.SeekOrigin.Begin)
                                                   Dim imageSource As WriteableBitmap = PictureDecoder.DecodeJpeg(resultArgs.ChosenPhoto)
                                                   Image1.Source = imageSource
                                               Else
                                                   saveButton.IsEnabled = False
                                                   Exit Sub
                                               End If
                                           End Sub
        MyBase.OnNavigatedTo(e)
    End Sub




    Private Sub saveButton_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles saveButton.Click

        Dim myUploadUri As String = String.Empty
        imageFileName = DateTime.Now.ToString("yyyyMMddHHmmss") & ".jpg"
        myUploadUri = String.Format(UploadUri, imageFileName)

        'Dim myByteRead As Integer = ImageData.Read(imageByte, 0, 4096)
        'ImageData.Flush()

        Dim myWebClient As New WebClient
        myWebClient.Headers(HttpRequestHeader.ContentLength) = CStr(imageByte.Length)
        'myWebClient.Headers(HttpRequestHeader.Accept) = "*/*"
        myWebClient.Headers(HttpRequestHeader.ContentType) = "image/jpeg" '"application/octet-stream"

        AddHandler myWebClient.OpenWriteCompleted, Sub(mySender As Object, myArgs As OpenWriteCompletedEventArgs)
                                                       If myArgs.Error Is Nothing = True Then
                                                           Dim outputStream As Stream = myArgs.Result
                                                           outputStream.Write(imageByte, 0, imageByte.Length)
                                                           outputStream.Close()
                                                           MessageBox.Show(imageFileName & "を保存しました。")
                                                           ichiranButton.IsEnabled = True
                                                       End If

                                                   End Sub
        Dim myUri As Uri = New Uri(myUploadUri, UriKind.Absolute)
        myWebClient.OpenWriteAsync(myUri)
    End Sub




    Private Sub cameraButton_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles cameraButton.Click
        myCameraTask.Show()
        saveButton.IsEnabled = True
    End Sub

    Private Sub ichiranButton_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles ichiranButton.Click
        NavigationService.Navigate(New Uri("/ImageShowPage.xaml", UriKind.Relative))
    End Sub
End Class
